/************************************************************/
/* QG8ŌXΌvB\ɂ̓OtBbNLCDgp           */
/* _gȂꍇansiis.libNB       */
/* _gꍇansifs.libNB           */
/*              Copyright (c)  since 2007/08/08 */
/* xZT[́AxωɂqBȉ͉xωɔ */
/* Y̕ϓȈՓIɋL^By:ቷ1.595V 1.760V   */
/************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "derivative.h" /* include peripheral declarations */
#include "PW10164lcd.h"
#include "GPIOSPI.h"

#define _DEBUG_

#define _CPU_CLOCK_  (8000000UL)
#define _BUS_CLOCK_  (4000000UL)
#define PERIOD_1s    (_BUS_CLOCK_ / 128)
#define PERIOD_3R9ms  (_BUS_CLOCK_ / 128 / 256)
#define PERIOD_7R8ms  (_BUS_CLOCK_ / 128 / 128)
#define PERIOD_15R6ms  (_BUS_CLOCK_ / 128 / 64)
#define PERIOD_62R5ms  (_BUS_CLOCK_ / 128 / 16)

#ifdef  _DEBUG_
#define  WAIT
#define  STOP
#else  /*_DEBUG_*/
#define  WAIT    __asm WAIT;
#define  STOP    __asm STOP;
#endif  /*_DEBUG_*/

#define  OVER_SAMPLE 256  /*I[o[Tv*/

#define  AN_X_AXIS   PTAD_PTAD0    /*xZT[ X*/
#define  AN_Y_AXIS   PTAD_PTAD1    /*xZT[ Y*/
#define  AN_Z_AXIS   PTAD_PTAD2    /*xZT[ Z*/
#define  SLEEP       PTAD_PTAD3    /*xZT[ SLEEP[qB1ŃANeBu*/
#define  BKGD        PTAD_PTAD4    /*BKGD[q*/
#define  RST         PTAD_PTAD5    /*RESET[q*/

#define  RXD         PTBD_PTBD0    /*UART RXD*/
#define  TXD         PTBD_PTBD1    /*UART TXD*/
/*bit25܂łGPIOSPI.Hɒ`*/
#define  SW2         PTBD_PTBD6    /*SW2*/
#define  SW2_MASK    0x40

/*ȉ3.3V̑\l*/
#define  X_OFFSET    (507.97 * OVER_SAMPLE)
#define  X_MAX       ((756.8 - 507.97) * OVER_SAMPLE)
#define  X_MIN       ((756.8 - 507.97) * OVER_SAMPLE)

#define  Y_OFFSET    (477.42 * OVER_SAMPLE)
#define  Y_MAX       ((756.8 - 477.42) * OVER_SAMPLE)
#define  Y_MIN       ((756.8 - 477.42) * OVER_SAMPLE)

#define  Z_OFFSET    (479.0 * OVER_SAMPLE)
#define  Z_MAX       ((784.14 - 479.0) * OVER_SAMPLE)
#define  Z_MIN       ((784.14 - 479.0) * OVER_SAMPLE)

#define  BAUD_RATE_9600   (_BUS_CLOCK_ / 16 / 9600)
#define  BAUD_RATE_19200  (_BUS_CLOCK_ / 16 / 19200)
#define  BAUD_RATE_38400  (_BUS_CLOCK_ / 16 / 38400)

#define  TEMPERATUER_CH  0x1a
#define  BAND_GYAP_CH    0x1b
#define  VBAT_LINE   6
#define  TEMP_LINE   6

typedef struct
{
  long x;
  long y;
  long z;
  long Vgap;
  long Vtemp;
} AXIS_L;

typedef struct
{
  struct
  {
    long offset;
    long max;
    long min;
  } x;
  struct
  {
    long offset;
    long max;
    long min;
  } y;
  struct
  {
    long offset_x_left;
    long offset_x_right;
    long offset_y_up;
    long offset_y_dwn;
    long max;
  } z;
} AXIS_PARAMETER;

/****************************************************************/
/* ϐ̊F                                             */
/****************************************************************/
AXIS_PARAMETER parm =
{
  {X_OFFSET, X_MAX, X_MIN},
  {Y_OFFSET, Y_MAX, Y_MIN},
  {Z_OFFSET, Z_OFFSET, Z_OFFSET, Z_MAX},
};

/*Xg[Ẅ̃t*/
AXIS_PARAMETER *flash_axis_backup = ((AXIS_PARAMETER *)0xE020);
char *signature = ((char *)0xE000);
void *storage = ((void *)0xE100);

unsigned char sw_status;
int ad_convert_end;
AXIS_L ad_multi;
int ad_int_count;

const char hamayan[] = "Copyright(c) hamayan";

extern const unsigned short DigiPixWidth;
extern const unsigned short DigiPixHeight;
extern const unsigned char DigiGraphicBMPTable[];

extern const unsigned short SmallDigiPixWidth;
extern const unsigned short SmallDigiPixHeight;
extern const unsigned char SmallDigiGraphicBMPTable[];

extern const unsigned short DotPixWidth;
extern const unsigned short DotPixHeight;
extern const unsigned char DotGraphicBMPTable[];

extern const unsigned short Cali04PixWidth;
extern const unsigned short Cali04PixHeight;
extern const unsigned char Cali04GraphicBMPTable[];

extern const unsigned short TitlePixWidth;
extern const unsigned short TitlePixHeight;
extern const unsigned char TitleGraphicBMPTable[];

extern const unsigned short hamaPixWidth;
extern const unsigned short hamaPixHeight;
extern const unsigned char hamaGraphicBMPTable[];

extern const unsigned short Arrow1PixWidth;
extern const unsigned short Arrow1PixHeight;
extern const unsigned char Arrow1GraphicBMPTable[];

extern const unsigned short Arrow2PixWidth;
extern const unsigned short Arrow2PixHeight;
extern const unsigned char Arrow2GraphicBMPTable[];

extern const unsigned short Arrow3PixWidth;
extern const unsigned short Arrow3PixHeight;
extern const unsigned char Arrow3GraphicBMPTable[];

extern const unsigned short Arrow4PixWidth;
extern const unsigned short Arrow4PixHeight;
extern const unsigned char Arrow4GraphicBMPTable[];

extern const unsigned short Msg02PixWidth;
extern const unsigned short Msg02PixHeight;
extern const unsigned char Msg02GraphicBMPTable[];

extern const unsigned short TempPixWidth;
extern const unsigned short TempPixHeight;
extern const unsigned char TempGraphicBMPTable[];

extern const unsigned short VBatPixWidth;
extern const unsigned short VBatPixHeight;
extern const unsigned char VBatGraphicBMPTable[];

extern const unsigned short BatteryPixWidth;
extern const unsigned short BatteryPixHeight;
extern const unsigned char BatteryGraphicBMPTable[];

extern const double tilt2sin[];
extern const int tilt2sin_size;

/************************************************************/
/* vg^Cv錾                                         */
/************************************************************/
#if 0
static void NumFontDisplay( unsigned char x, unsigned char y,int num );
#else
/*
#define  NumFontDisplay( x, y, num ) do{ Bit8DataDisplay( DigiGraphicBMPTable + num * 16, x, y, 16 ); \
                                         Bit8DataDisplay( DigiGraphicBMPTable + 160 + num * 16, x, y + 1, 16 ); }while(0)
*/
#define  NumFontDisplay( x, y, num ) do{ Bit8DataDisplay( DigiGraphicBMPTable + num * 10, x, y, 10 ); \
                                         Bit8DataDisplay( DigiGraphicBMPTable + 104 + num * 10, x, y + 1, 10 ); }while(0)
#endif


#if 0
static void SmallNumFontDisplay( unsigned char x, unsigned char y, int num );
#else
#define  SmallNumFontDisplay( x, y, num )  Bit8DataDisplay( SmallDigiGraphicBMPTable + num * 5, x, y, 5 )
#endif


static void Axis_Display( int axis, unsigned char vertical );
#define  X_Axis_Display( x_axis )  Axis_Display( x_axis, 1 )
#define  Y_Axis_Display( y_axis )  Axis_Display( y_axis, 3 )
#define  Z_Axis_Display( z_axis )  Axis_Display( z_axis, 5 )

static void Small_Number_Display( int value, unsigned char x, unsigned char y );
#define  Battery( value )  Small_Number_Display( (int)value, (unsigned char)(VBatPixWidth + 1), VBAT_LINE )
#define  Temperatuer( value )  Small_Number_Display( (int)value, (unsigned char)(50 + TempPixWidth + 1), TEMP_LINE )

static void Bit8DataDisplay( const void *bmp, unsigned char x, unsigned char y, int size );
static void Paint( const void *bmp, unsigned char x, unsigned char y, int height, int width );
static void TiltDisplay( AXIS_L *axis );

static int search_from_sin_table( const double tbl[], long data, long scale, int limit );

static int calibration_mode( AXIS_L *axis, int mode );
static char *ItoA04( char *dest, int value );
static void RewriteConfigration( void );
#if 0
int FlashCopy( unsigned int adr, void *data, unsigned short size );
int FlashErase( unsigned int adr );
#else
int FlashCopy( void *adr, void *data, unsigned short size );
int FlashErase( void *adr );
#endif
void SCI_Init( unsigned short brr );
void SCIPuts( const char *msg );

static void VddDisplay( int voltage );
static void TiltDisplay( AXIS_L *axis );
#define  VbatDisplay()  Bit8DataDisplay( BatteryGraphicBMPTable, 0, VBAT_LINE, (int)BatteryPixWidth )

/************************************************************/
/* vOmain                                           */
/************************************************************/
void main(void)
{
  int calib_mode;
  AXIS_L ad;
  int Vdd;

  /*watch dog timer̒~*/
#ifdef  _DEBUG_
  SOPT1_COPE = 0;
/*  SOPT1_BKGDPE = 0;*/
#else  /*_DEBUG_*/
  SOPT1 = SOPT1_STOPE_MASK | SOPT1_RSTPE_MASK;
#endif  /*_DEBUG_*/

  /*NbN̏*/
  ICSC1 = 0x04;  /*0b00 000 1 0 0*/
  ICSC2_BDIV = 1;  /*oXNbN2*/
  ICSTRM = *((unsigned char *)0xffaf);
  ICSSC_FTRIM = (*((unsigned char *)0xffae) & 0x01) ? 1 : 0;
  FCDIV = 19;  /*FLASH CLK = 200Khz*/

  /*ėp|[g̐ݒ*/
  PTADD = 0x18;	/*0001 1000*/
  PTBDD = 0xbe;	/*1011 1110*/
  SLEEP = 1;  /*MM2860SLEEP*/
//  LCD_CS = 0;

  /*RESET[qLɂ̂ƁAfobN[qo͒[qɐ؂ւ*/
  PTADD_PTADD4 = 1;
  PTADS_PTADS4 = 1;
  PTBPE_PTBPE6 = 1;  /*SW2ڑĂ[q̃vAbvCl[u*/

  /*VA|[g̏*/
#if 0
  SCI_Init( 13 );
  SCIPuts( "Vcc,Temp,X,Y,Z\r\n" );
#endif

  /*FLASH ROM̃f[^mF̈̏`FbNAĂȂ́AsB*/
  if( strncmp( signature, hamayan, sizeof(hamayan) ) != 0 )
  {
    RewriteConfigration();
  }
  parm = *flash_axis_backup;

  /*@\^C}[gp*/
  TPMSC = 0x07;     /*0b0 0 00 111 ^C}[~Asystem clock / 128*/
//  TPMMOD = PERIOD_15R6ms;  /*ݒ*/
  TPMMOD = PERIOD_7R8ms;  /*ݒ*/
  TPMSC_TOIE = 1;   /*interrupt enable*/
  TPMSC_CLKSx = 1;  /*oXNbN̑I*/

  /*ADC setting*/
  ADCSC1_AIEN = 1;  /* Enable interrupts */
  ADCSC2_ADTRG = 0; /* Select S/W trigger*/
  /*FADCK0.4M`4MHz̊Ԃɓ鎖*/
  ADCCFG = 0x98;    /* ADLP = 1  0b1001 1000*/
/*  ADCCFG = 0xf9;*/    /* ADLP = 1  0b1111 1001
                     ADIV=input clock/8
                     ADLSMP=long sample time
                     MODE=10bit conversion
                     ADICLK=bus clock / 2 */
  APCTL1 = 0x07;  /*Enable pins 16,15,14 as ADC inputs*/
  SPMSC1_BGBE = 1;  /*ohMbvLɂ*/

  /*LCD̏*/
  PWDisplayInit();
  ClearDisplay();

  /*ӏ̕\*/
  Bit8DataDisplay( TitleGraphicBMPTable, 0, 0, TitlePixWidth );
//  Bit8DataDisplay( hamaGraphicBMPTable, 0, 7, hamaPixWidth );

  EnableInterrupts; /* enable interrupts */

  for( calib_mode = 0; ; )
  {
    WAIT;  /*xȓd̓[hɓB荞݂ƁA̖̎߂sB*/
    if( ad_convert_end != 0 )
    {
      /*TvOꂽf[^*/
      ad = ad_multi;
      (void)memset( &ad_multi, 0, sizeof(ad_multi) );
      ad_convert_end = 0;

      /*XCb`Ă鎞́ALu[Vɓ*/
      if( sw_status & SW2_MASK )
      {
        calib_mode = calibration_mode( &ad, calib_mode );
        sw_status &= ~SW2_MASK;
      }
      else if( calib_mode == 0 )
      {
        /*̌X߂*/
        TiltDisplay( &ad );
        /*dd߂*/
        Vdd = (unsigned long)(1023UL * 1200 * OVER_SAMPLE / ad.Vgap);
        VddDisplay( Vdd );
      }
      else ;
    }
  }
}

/************************************************************/
/* SINe[u2ؒTgČB               */
/* Ȃ-1ԂB                               */
/************************************************************/
static int search_from_sin_table( const double tbl[], long data, long scale, int limit )
{
  int i,lower,middle,upper;
  double value;

  if( data == 0 ) return 0;
  if( data < 0 ) data = -data;
#if 1
  value = (double)data / (double)scale;
#else
  value = (double)data / (double)scale / 1.4142135624;
#endif
  if( value > tbl[ limit - 1 ] ) return (-1);

  for( i = 1, middle = limit / 2, lower = 0, upper = limit - 1; i < limit; i *= 2 )
  {
    if( value > tbl[ middle ] )
    {
      lower = middle;
    }
    else if( value < tbl[ middle ] )
    {
      upper = middle;
    }
    else
    {
      return middle;
    }

    middle = (upper + lower) / 2;
  }

  if( (tbl[ upper ] - value) > (value - tbl[ lower ]) )
    return lower;
  else
    return upper;
}

/************************************************************/
/* X\                                                 */
/************************************************************/
static void TiltDisplay( AXIS_L *axis )
{
  unsigned char pos;
  int index;
  void *ptr;
  long scale,z_value,z_scale;

  /*\̈̃NA*/
  LCD_CS = 0;
  for( pos = 1; pos < 5; pos++ ) ClearArea( pos, 0, 101 );
  LCD_CS = 1;

  /*X̕\s*/
  if( axis->x >= parm.x.offset )
  {
    ptr = (const void *)Arrow4GraphicBMPTable;
    pos = 0;
    scale = parm.x.max;
    z_scale = parm.z.max - parm.z.offset_x_left;
    z_value = axis->z - parm.z.offset_x_left;
  }
  else
  {
    ptr = (const void *)Arrow2GraphicBMPTable;
    pos = 84;
    scale = parm.x.min;
    z_scale = parm.z.max - parm.z.offset_x_right;
    z_value = axis->z - parm.z.offset_x_right;
  }

  Paint( ptr, pos, 1, 16, 16 );

  index = search_from_sin_table( tilt2sin, axis->x - parm.x.offset, scale, tilt2sin_size );
  if( index >= 0 )
    X_Axis_Display( index * 25 );
  else
  {
    index = search_from_sin_table( tilt2sin, z_value, z_scale, tilt2sin_size );
    X_Axis_Display( (360 - index) * 25 );
  }

  /*Y̕\s*/
  if( axis->y >= parm.y.offset )
  {
    ptr = (const void *)Arrow1GraphicBMPTable;
    pos = 0;
    scale = parm.y.max;
    z_scale = parm.z.max - parm.z.offset_y_up;
    z_value = axis->z - parm.z.offset_y_up;
  }
  else
  {
    ptr = (const void *)Arrow3GraphicBMPTable;
    pos = 84;
    scale = parm.y.min;
    z_scale = parm.z.max - parm.z.offset_y_dwn;
    z_value = axis->z - parm.z.offset_y_dwn;
  }
  Paint( ptr, pos, 3, 16, 16 );

  index = search_from_sin_table( tilt2sin, axis->y - parm.y.offset, scale, tilt2sin_size );
  if( index >= 0 )
    Y_Axis_Display( index * 25 );
  else
  {
    index = search_from_sin_table( tilt2sin, z_value, z_scale, tilt2sin_size );
    Y_Axis_Display( (360 - index) * 25 );
  }
}

/************************************************************/
/* Lu[V                                   */
/************************************************************/
static int calibration_mode( AXIS_L *axis, int mode )
{
  unsigned char i;

  /*\̈̃NA*/
  LCD_CS = 0;
  for( i = 1; i < 7; i++ ) ClearArea( i, 0, 101 );
  LCD_CS = 1;

  switch( mode )
  {
    case 0 :  /*ɒuāA{^lɃbZ[W\B*/
      Paint( (const void *)Cali04GraphicBMPTable, 0, 1, Cali04PixHeight, Cali04PixWidth );  /*zuv*/
      break;

    case 1 :  /*ԂAXAYOffsetƁAZ̍ő傪TvOł̂ŁAɐiށB*/
    case 2 :  /*X𐂒ɂAX̍őAZOffsetTvOł̂ŁAɐiށB*/
    case 3 :  /*X𐂒ɂAX̍őAZOffsetTvOł̂ŁAɐiށB*/
    case 4 :  /*X𐂒ɂAX̍őAZOffsetTvOł̂ŁAɐiށB*/

#if 1
      switch( mode )
      {
        case 1 :  /*ԂAXAYOffsetƁAZ̍ő傪TvOł̂ŁAɐiށB*/
          parm.x.offset = axis->x;  /*VX̃ItZbgl̑*/
          parm.y.offset = axis->y;  /*VỸItZbgl̑*/
          parm.z.max = axis->z;     /*VZ̍߂O̒l̑*/
          Paint( (const void *)Arrow4GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;

        case 2 :  /*󂩂AX̍őAZOffsetTvOł̂ŁAɐiށB*/
          parm.x.max = axis->x - parm.x.offset;  /*X̍őXP[Ƃ*/
          parm.z.offset_x_left = axis->z;  /*VZ̃ItZbgl̑*/
          Paint( (const void *)Arrow2GraphicBMPTable, 0, 1, 16, 16 );  /*E̕\*/
          break;

        case 3 :  /*E󂩂AX̍ŏTvOł̂ŁAɐiށB*/
          parm.x.min = parm.x.offset - axis->x;  /*X̍őXP[Ƃ*/
          parm.z.offset_x_right = axis->z;  /*VZ̃ItZbgl̑*/
          Paint( (const void *)Arrow3GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;

        case 4 :  /*󂩂AY̍ŏTvOł̂ŁAɐiށB*/
        default :
          parm.y.min = parm.y.offset - axis->y;  /*Y̍őXP[Ƃ*/
          parm.z.offset_y_dwn = axis->z;  /*VZ̃ItZbgl̑*/
          Paint( (const void *)Arrow1GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;
      }
      Paint( (const void *)Msg02GraphicBMPTable, 16, 1, Msg02PixHeight, Msg02PixWidth );  /*Y𐂒*/
      break;

    default :  /*Y𐂒ɂAY̍ő傪TvOł̂ŁAVp[^L^B*/
      parm.y.max = axis->y - parm.y.offset;  /*Y̍őXP[Ƃ*/
      parm.z.offset_y_up = axis->z;  /*VZ̃ItZbgl̑*/
      RewriteConfigration();  /*VItZbglAőXP[lFLASH ROM̈ɕۑB*/
      return 0;
  }
#else
      switch( mode )
      {
        case 1 :  /*ԂAXAYOffsetƁAZ̍ő傪TvOł̂ŁAɐiށB*/
          parm.z.max = axis->z;     /*VZ̍߂O̒l̑*/
          Paint( (const void *)Arrow4GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;

        case 2 :  /*󂩂AX̍őAZOffsetTvOł̂ŁAɐiށB*/
          parm.x.max = axis->x;  /*X̍őXP[Ƃ*/
          parm.z.offset = axis->z;  /*VZ̃ItZbgl̑*/
          parm.z.max = parm.z.max - axis->z;  /*Z̍őXP[Ƃ*/
          Paint( (const void *)Arrow2GraphicBMPTable, 0, 1, 16, 16 );  /*E̕\*/
          break;

        case 3 :  /*E󂩂AX̍ŏTvOł̂ŁAɐiށB*/
          parm.x.min = axis->x;  /*X̍őXP[Ƃ*/
          Paint( (const void *)Arrow3GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;

        case 4 :  /*󂩂AY̍ŏTvOł̂ŁAɐiށB*/
        default :
          parm.y.min = axis->y;  /*Y̍őXP[Ƃ*/
          Paint( (const void *)Arrow1GraphicBMPTable, 0, 1, 16, 16 );  /*̕\*/
          break;
      }
      Paint( (const void *)Msg02GraphicBMPTable, 16, 1, Msg02PixHeight, Msg02PixWidth );  /*Y𐂒*/
      break;

    default :  /*Y𐂒ɂAY̍ő傪TvOł̂ŁAVp[^L^B*/
      parm.x.offset = (parm.x.max + parm.x.min) / 2;  /*X̍őXP[Ƃ*/
      parm.x.max = parm.x.max - parm.x.offset;  /*X̍őXP[Ƃ*/
      parm.x.min = parm.x.offset - parm.x.min;  /*X̍ŏXP[Ƃ*/

      parm.y.offset = (parm.y.max + parm.y.min) / 2;  /*X̍őXP[Ƃ*/
      parm.y.max = parm.y.max - parm.y.offset;  /*Y̍őXP[Ƃ*/
      parm.y.min = parm.y.offset - parm.y.min;  /*Y̍ŏXP[Ƃ*/
      RewriteConfigration();  /*VItZbglAőXP[lFLASH ROM̈ɕۑB*/
      return 0;
  }
#endif

  return ++mode;
}

/************************************************************/
/* RtBM[V̈̏                     */
/************************************************************/
static void RewriteConfigration( void )
{
  char backup[ 256 ];  /*X^bN̈m*/

  /*rbg}bvf[^obNAbvĂ*/
  (void)memcpy( backup, storage, sizeof( backup ) );  /*rbg}bvf[^̈ꕔ́AEEPROMɎgĂFLASH ROM̈ꕔubNɑ݂*/

  DisableInterrupts; /* disable interrupts */
  (void)FlashErase( signature );  /*FLASH ROM̓̈*/
  (void)FlashCopy( signature, (void *)hamayan, sizeof( hamayan ) );  /*FLASH ROM̓̈ɏ*/
  (void)FlashCopy( flash_axis_backup, &parm, sizeof( parm ) );  /*VItZbgyуXP[FLASH ROM̓̈ɏ*/

  (void)FlashCopy( storage, backup, sizeof( backup ) );  /*ۑĒurbg}bvf[^FLASH ROM̓̈ɏ*/
  EnableInterrupts; /* enable interrupts */
}

/************************************************************/
/* AXIS DISPLAY                                             */
/************************************************************/
static void Axis_Display( int axis, unsigned char vertical )
{
  unsigned char pos;
  int divider;
  char blank[ 16 ];

  for( pos = 20, divider = 1000; divider > 0; divider /= 10 )
  {
    /*DOT\ʒu߂B*/
    if( (divider == 10 && (vertical == 1 || vertical == 3))
      || (divider == 100 && vertical == 5) )
    {
      Bit8DataDisplay( DotGraphicBMPTable, pos, vertical + 1, 5 );  /*DOT̕\*/
      pos += 5;
    }

    /*擪0̏ꍇ̓uN\B*/
    if( divider == 1000 && axis < 1000 )
    {
      (void)memset( blank, 0, sizeof( blank ) );
      Bit8DataDisplay( blank, pos, vertical, sizeof( blank ) );
      Bit8DataDisplay( blank, pos, vertical + 1, sizeof( blank ) );
    }
    else
      NumFontDisplay( pos, vertical, axis / divider );  /**/

    axis %= divider;
    pos += 11;
  }
}

/************************************************************/
/* Small Number Display                                     */
/************************************************************/
static void Small_Number_Display( int value, unsigned char x, unsigned char y )
{
#if 0
  if( value < 0 ) value = 0;
  else if( value > 9999 ) value = 9999;
  else ;

  SmallNumFontDisplay( x + 0, y, value / 1000 );  /*1000*/
  value %= 1000;
  SmallNumFontDisplay( x + 6, y, value / 100 );  /*100*/
  value %= 100;
  SmallNumFontDisplay( x + 12, y, value / 10 );  /*10*/
  value %= 10;
  SmallNumFontDisplay( x + 18, y, value );  /*1*/
#else
  int divider;

  if( value < 0 ) value = 0;
  else if( value > 9999 ) value = 9999;
  else ;

  for( divider = 1000; divider > 0; divider /= 10 )
  {
    SmallNumFontDisplay( x, y, value / divider );
    value %= divider;
    x += 6;
  }
#endif
}

/************************************************************/
/* ITOA 4o[W                                       */
/************************************************************/
static char *ItoA04( char *dest, int value )
{
  dest[ 0 ] = value / 1000 | '0';
  value %= 1000;
  dest[ 1 ] = value / 100 | '0';
  value %= 100;
  dest[ 2 ] = value / 10 | '0';
  value %= 10;
  dest[ 3 ] = value | '0';
  dest[ 4 ] = '\0';

  return dest;
}

/************************************************************/
/* FONT\                                             */
/************************************************************/
#if 0
static void NumFontDisplay( unsigned char x, unsigned char y,int num )
{
  LCD_CS = 0;
  MoveTo( x, y );
  GPIOSPISendBuffer( (unsigned char *)DigiGraphicBMPTable + (0 * 20 * 8) + (num * 16), 16 );
  MoveTo( x, y + 1 );
  GPIOSPISendBuffer( (unsigned char *)DigiGraphicBMPTable + (1 * 20 * 8) + (num * 16), 16 );
  LCD_CS = 1;
}
#endif

/************************************************************/
/* FONT\                                       */
/************************************************************/
#if 0
static void SmallNumFontDisplay( unsigned char x, unsigned char y, int num )
{
  LCD_CS = 0;
  MoveTo( x, y );
  GPIOSPISendBuffer( (unsigned char *)SmallDigiGraphicBMPTable + (num * 5), 5 );
  LCD_CS = 1;
}
#endif

/************************************************************/
/* 8bit̃rbg}bvf[^p̏o͊֐             */
/************************************************************/
static void Bit8DataDisplay( const void *bmp, unsigned char x, unsigned char y, int size )
{
  LCD_CS = 0;
  MoveTo( x, y );
  GPIOSPISendBuffer( (unsigned char *)bmp, size );
  LCD_CS = 1;
}

/************************************************************/
/* PAINT֐                                                */
/************************************************************/
static void Paint( const void *bmp, unsigned char x, unsigned char y, int height, int width )
{
  unsigned char *ptr = (unsigned char *)bmp;

  width = (((width - 1) / 8) + 1) * 8;
  for( ; height > 0; height -= 8 )
  {
    Bit8DataDisplay( ptr, x, y++, width );
    ptr += width;
  }
}

/************************************************************/
/* dd\                                             */
/************************************************************/
static void VddDisplay( int voltage )
{
  VbatDisplay();
#if 0
  Battery( voltage );
#else
  Z_Axis_Display( voltage );
#endif
}

/************************************************************/
/* ICx\                                           */
/************************************************************/
static void TemperatuerDisplay( int voltage, unsigned short Vtemp )
{
  long temper,TempSlopeHot,TempSlopeCold,CalcVdd,ADCRTemp25;

  TempDisplay();  /*ڂ̕\*/
  CalcVdd = voltage;
  ADCRTemp25 = 717300L * OVER_SAMPLE / CalcVdd;
  TempSlopeHot = 181000L * OVER_SAMPLE / CalcVdd;
  TempSlopeCold = 168400L * OVER_SAMPLE / CalcVdd;

  if( Vtemp > ADCRTemp25 )  /*25艷xႢƁAVtempVTEMP25傫Ȃ*/
  {
    temper = 250L - ((Vtemp - ADCRTemp25) * 250L) / TempSlopeCold * 4;
  }
  else
  {
    temper = 250L + ((ADCRTemp25 - Vtemp) * 250L) / TempSlopeHot * 4;
  }
  Temperatuer( temper );
}

/****************************************************************/
/* tpm interrupt 7.8ms̊荞݂ƂȂ                      */
/****************************************************************/
interrupt 7 void TPM_C_MATCH_ISR(void)
{
  static unsigned char old = 0xff;  /*ߋ̃XCb`̏ԂL^Ēu*/

  TPMSC_TOF = 0;	/*clear status*/

  ADCSC1_ADCH = 0; /*ϊ`l̑IƁAϊJn*/

  /*XCb`̃TvO*/
  if( !SW2 && (old & SW2_MASK) && !(sw_status & SW2_MASK) )
  {  /*ÕTvOł1ŁÃTvO0̎Ǎo*/
    sw_status |= SW2_MASK;
    (void)memset( &ad_multi, 0, sizeof(ad_multi) );
    ad_int_count = 0;
  }
  old = PTBD;
}

/****************************************************************/
/* adc interrupt                                                */
/****************************************************************/
interrupt 19 void ADC_ISR( void )
{
  unsigned short data;

  data = ADCR;  /*10bit̂ݗL*/
  if( ad_convert_end == 0 )  /*ϐւ̏㏑h~*/
  {
    switch( ADCSC1_ADCH )
    {
      case 0 :  /*X̃TvO*/
        ADCSC1_ADCH = 1;  /*̃`l̕ϊv*/
        ad_multi.x += data;
        break;

      case 1 :  /*ỸTvO*/
        ADCSC1_ADCH = 2;  /*̃`l̕ϊv*/
        ad_multi.y += data;
        break;

      case 2 :  /*Z̃TvO*/
        ADCSC1_ADCH = BAND_GYAP_CH;  /*̃`l̕ϊv*/
        ad_multi.z += data;
        break;

      default :  /*ohMbṽTvO*/
        ad_multi.Vgap += data;
        if( ++ad_int_count >= OVER_SAMPLE )
        {
          ad_convert_end = 1;
          ad_int_count = 0;
        }
        break;
    }
  }
}

/************************************************************/
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
