/************************************************************/
/* VAo                                           */
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

#define _CPU_CLOCK_  (8000000UL)
#define _BUS_CLOCK_  (4000000UL)

#define  RXD         PTBD_PTBD0    /*UART RXD*/
#define  TXD         PTBD_PTBD1    /*UART TXD*/

/****************************************************************/
/* ϐ̊F                                             */
/****************************************************************/

/************************************************************/
/* vg^Cv錾                                         */
/************************************************************/
void SCI_Init( unsigned short brr );
void SCIPuts( const char *msg );

/************************************************************/
/* SCI                                                */
/************************************************************/
void SCI_Init( unsigned short brr )
{
  char rcv_data;

  /*SCI setting*/
  SCIBD = brr;  /*1319200bps*/
  SCIC1 = 0x00;  /*8bit stop=1 non parity*/
#if 0
  SCIC2 = SCIC2_RE_MASK | SCIC2_TE_MASK | SCIC2_RIE_MASK; /**/
  SCIC3 = SCIC3_FEIE_MASK | SCIC3_ORIE_MASK; /**/
#else
  SCIC2 =SCIC2_TE_MASK; /**/
#endif
  rcv_data = SCIS1;  /*dummy read*/
  rcv_data = SCID;  /*dummy read*/
}

/****************************************************************/
/* SCIPuts                                                      */
/****************************************************************/
void SCIPuts( const char *msg )
{
  char *ptr;
  unsigned char dummy;	   // dummy var for reading SCIS1
  
  dummy = SCIS1;   // 1st half of TDRE clear procedure
  ptr = (char *)msg;
  while( *ptr )
  {
    while( SCIS1_TDRE == 0 ) ;
    SCID = *ptr++;
  }
  while( SCIS1_TC == 0 ) ;
}

/************************************************************/
/*              Copyright (c)  since 2007/08/08 */
/************************************************************/
